'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _Header = require('../sections/Header');

var _Header2 = _interopRequireDefault(_Header);

var _Footer = require('../sections/Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _LoginModal = require('../login/LoginModal');

var _LoginModal2 = _interopRequireDefault(_LoginModal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global window */

var propTypes = {
  decorated: _propTypes2.default.bool,
  history: _propTypes2.default.object,
  openModalName: _propTypes2.default.string,
  perms: _propTypes2.default.instanceOf(_immutable2.default.Map),
  screenName: _propTypes2.default.string,
  username: _propTypes2.default.string.isRequired,
  children: _propTypes2.default.node,
  closeModal: _propTypes2.default.func,
  resetLogin: _propTypes2.default.func
};

var defaultProps = {
  decorated: true
};

var ProtectedPage = function (_Component) {
  _inherits(ProtectedPage, _Component);

  function ProtectedPage() {
    _classCallCheck(this, ProtectedPage);

    var _this = _possibleConstructorReturn(this, (ProtectedPage.__proto__ || Object.getPrototypeOf(ProtectedPage)).call(this));

    _this.handleLoginSuccess = _this.handleLoginSuccess.bind(_this);
    return _this;
  }

  _createClass(ProtectedPage, [{
    key: 'handleLoginSuccess',
    value: function handleLoginSuccess() {
      var _props = this.props,
          closeModal = _props.closeModal,
          resetLogin = _props.resetLogin;


      window.setTimeout(function () {
        if (resetLogin) {
          resetLogin();
        }

        if (closeModal) {
          closeModal();
        }
      }, 0);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          decorated = _props2.decorated,
          history = _props2.history,
          openModalName = _props2.openModalName,
          perms = _props2.perms,
          screenName = _props2.screenName,
          username = _props2.username,
          children = _props2.children,
          closeModal = _props2.closeModal;


      var header = decorated ? _react2.default.createElement(_Header2.default, { history: history, perms: perms, screenName: screenName || username }) : null;

      var footer = decorated ? _react2.default.createElement(_Footer2.default, null) : null;

      return _react2.default.createElement(
        'div',
        null,
        header,
        children,
        footer,
        _react2.default.createElement(_LoginModal2.default, {
          isOpen: openModalName === _LoginModal2.default.modalName,
          onCloseButtonClick: closeModal,
          onSuccess: this.handleLoginSuccess
        })
      );
    }
  }]);

  return ProtectedPage;
}(_react.Component);

exports.default = ProtectedPage;


ProtectedPage.propTypes = propTypes;
ProtectedPage.defaultProps = defaultProps;