'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _reactIntl = require('react-intl');

var _cspaceLayout = require('cspace-layout');

var _CancelButton = require('../navigation/CancelButton');

var _CancelButton2 = _interopRequireDefault(_CancelButton);

var _SaveButton = require('../record/SaveButton');

var _SaveButton2 = _interopRequireDefault(_SaveButton);

var _RevertButton = require('../record/RevertButton');

var _RevertButton2 = _interopRequireDefault(_RevertButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var messages = (0, _reactIntl.defineMessages)({
  title: {
    'id': 'confirmRecordNavigationModal.title',
    'defaultMessage': 'Leave Record?'
  },
  prompt: {
    'id': 'confirmRecordNavigationModal.prompt',
    'defaultMessage': 'You\'re about to leave a record that has unsaved changes.'
  },
  cancel: {
    'id': 'confirmRecordNavigationModal.cancel',
    'defaultMessage': 'Don\'t leave'
  },
  save: {
    'id': 'confirmRecordNavigationModal.save',
    'defaultMessage': 'Save and continue'
  },
  revert: {
    'id': 'confirmRecordNavigationModal.revert',
    'defaultMessage': 'Revert and continue'
  }
});

var propTypes = {
  isOpen: _propTypes2.default.bool,
  isModified: _propTypes2.default.bool,
  isSavePending: _propTypes2.default.bool,
  validationErrors: _propTypes2.default.instanceOf(_immutable2.default.Map),
  onCancelButtonClick: _propTypes2.default.func,
  onCloseButtonClick: _propTypes2.default.func,
  onRevertButtonClick: _propTypes2.default.func,
  onSaveButtonClick: _propTypes2.default.func,
  onSaveButtonErrorBadgeClick: _propTypes2.default.func
};

var ConfirmRecordNavigationModal = function (_Component) {
  _inherits(ConfirmRecordNavigationModal, _Component);

  function ConfirmRecordNavigationModal() {
    _classCallCheck(this, ConfirmRecordNavigationModal);

    var _this = _possibleConstructorReturn(this, (ConfirmRecordNavigationModal.__proto__ || Object.getPrototypeOf(ConfirmRecordNavigationModal)).call(this));

    _this.renderButtonBar = _this.renderButtonBar.bind(_this);
    return _this;
  }

  _createClass(ConfirmRecordNavigationModal, [{
    key: 'renderButtonBar',
    value: function renderButtonBar() {
      var _props = this.props,
          isModified = _props.isModified,
          isSavePending = _props.isSavePending,
          validationErrors = _props.validationErrors,
          onCancelButtonClick = _props.onCancelButtonClick,
          onSaveButtonClick = _props.onSaveButtonClick,
          onSaveButtonErrorBadgeClick = _props.onSaveButtonErrorBadgeClick,
          onRevertButtonClick = _props.onRevertButtonClick;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_CancelButton2.default, {
          label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.cancel),
          onClick: onCancelButtonClick
        }),
        _react2.default.createElement(_SaveButton2.default, {
          isModified: isModified,
          isSavePending: isSavePending,
          label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.save),
          validationErrors: validationErrors,
          onClick: onSaveButtonClick,
          onErrorBadgeClick: onSaveButtonErrorBadgeClick
        }),
        _react2.default.createElement(_RevertButton2.default, {
          isModified: isModified,
          isSavePending: isSavePending,
          label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.revert),
          onClick: onRevertButtonClick
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          isOpen = _props2.isOpen,
          onCloseButtonClick = _props2.onCloseButtonClick;


      return _react2.default.createElement(
        _cspaceLayout.Modal,
        {
          isOpen: isOpen,
          title: _react2.default.createElement(
            'h1',
            null,
            _react2.default.createElement(_reactIntl.FormattedMessage, messages.title)
          ),
          closeButtonClassName: 'material-icons',
          closeButtonLabel: 'close',
          renderButtonBar: this.renderButtonBar,
          onCloseButtonClick: onCloseButtonClick
        },
        _react2.default.createElement(_reactIntl.FormattedMessage, messages.prompt)
      );
    }
  }]);

  return ConfirmRecordNavigationModal;
}(_react.Component);

exports.default = ConfirmRecordNavigationModal;


ConfirmRecordNavigationModal.modalName = 'ConfirmRecordNavigationModal';
ConfirmRecordNavigationModal.propTypes = propTypes;