'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = About;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _About = require('../../../styles/cspace-ui/About.css');

var _About2 = _interopRequireDefault(_About);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  title: {
    'id': 'about.title',
    'defaultMessage': 'Welcome to the CollectionSpace Demo'
  },
  contentHTML: {
    'id': 'about.contentHTML',
    'defaultMessage': '<p>\n        CollectionSpace is a free, open-source collections management application for museums,\n        historical societies, natural science collections, and more.\n      </p>\n      <p>\n        This demo site is running the\n        <a href="http://www.collectionspace.org/current_release/">current version</a> of the\n        <i>common</i> installation, which includes fields and procedures common to most collecting\n        organizations. If you\u2019re interested in a version of CollectionSpace configured to meet the\n        needs of a specific domain, please visit our\n        <a href="http://demo.collectionspace.org">demo landing page</a>\n        to view all available options. Examples include Anthropology, Botanical Garden, Fine Art,\n        Herbarium, and Local History &amp; Material Culture.\n      </p>\n      <p>\n        To log in, use the email <strong>admin@core.collectionspace.org</strong>, with the\n        case-sensitive password <strong>Administrator</strong>. To view in read-only mode, use the\n        email <strong>reader@core.collectionspace.org</strong> with the password\n        <strong>reader</strong>.\n      </p>\n      <p>\n        Not sure where to get started? Follow along with one of our quick-start guides:\n      </p>\n      <ul>\n        <li>\n          <span>Create a new object:</span>\n          <a href="http://bit.ly/newobjpdf">PDF</a>\n          <a href="https://vimeo.com/112212895">Screencast</a>\n        </li>\n        <li>\n          <span>Link to an image:</span>\n          <a href="http://bit.ly/linkimgpdf">PDF</a>\n          <a href="https://vimeo.com/112214418">Screencast</a>\n        </li>\n        <li>\n          <span>Add a storage location:</span>\n          <a href="http://bit.ly/storlocpdf">PDF</a>\n          <a href="https://vimeo.com/112818120">Screencast</a>\n        </li>\n      </ul>\n      <p>\n        We rebuild this demo site weekly so don\'t worry, you won\'t break it!\n      </p>'
  }
});

function About() {
  return _react2.default.createElement(
    'div',
    { className: _About2.default.common },
    _react2.default.createElement(
      'h2',
      null,
      _react2.default.createElement(_reactIntl.FormattedMessage, messages.title)
    ),
    _react2.default.createElement(_reactIntl.FormattedHTMLMessage, _extends({}, messages.contentHTML, { tagName: 'div' }))
  );
}