'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var ERR_NOT_FOUND = exports.ERR_NOT_FOUND = 'ERR_NOT_FOUND';
var ERR_NOT_ALLOWED = exports.ERR_NOT_ALLOWED = 'ERR_NOT_ALLOWED';
var ERR_UNKNOWN_RECORD_TYPE = exports.ERR_UNKNOWN_RECORD_TYPE = 'ERR_UNKNOWN_RECORD_TYPE';
var ERR_UNKNOWN_VOCABULARY = exports.ERR_UNKNOWN_VOCABULARY = 'ERR_UNKNOWN_VOCABULARY';
var ERR_MISSING_VOCABULARY = exports.ERR_MISSING_VOCABULARY = 'ERR_MISSING_VOCABULARY';
var ERR_UNKNOWN_SUBRESOURCE = exports.ERR_UNKNOWN_SUBRESOURCE = 'ERR_UNKNOWN_SUBRESOURCE';
var ERR_INVALID_CSID = exports.ERR_INVALID_CSID = 'ERR_INVALID_CSID';
var ERR_INVALID_RELATED_TYPE = exports.ERR_INVALID_RELATED_TYPE = 'ERR_INVALID_RELATED_TYPE';
var ERR_INVALID_SORT = exports.ERR_INVALID_SORT = 'ERR_INVALID_SORT';
var ERR_COMPUTE = exports.ERR_COMPUTE = 'ERR_COMPUTE';
var ERR_API = exports.ERR_API = 'ERR_API';

/*
 * Validation errors
 */

// Generic validation error. A field value is invalid, for an unspecified reason.
var ERR_VALIDATION = exports.ERR_VALIDATION = 'ERR_VALIDATION';

// An unexpected error occurred while trying to validate.
var ERR_UNABLE_TO_VALIDATE = exports.ERR_UNABLE_TO_VALIDATE = 'ERR_UNABLE_TO_VALIDATE';

// A required field does not have a value.
var ERR_MISSING_REQ_FIELD = exports.ERR_MISSING_REQ_FIELD = 'ERR_MISSING_REQ_FIELD';

// A field's value does not have the expected data type.
var ERR_DATA_TYPE = exports.ERR_DATA_TYPE = 'ERR_DATA_TYPE';

/*
 * Password reset errors
 */

var ERR_MISSING_EMAIL = exports.ERR_MISSING_EMAIL = 'ERR_MISSING_EMAIL';
var ERR_INVALID_EMAIL = exports.ERR_INVALID_EMAIL = 'ERR_INVALID_EMAIL';
var ERR_MISSING_PW = exports.ERR_MISSING_PW = 'ERR_MISSING_PW';
var ERR_MISSING_PW_CONFIRM = exports.ERR_MISSING_PW_CONFIRM = 'ERR_MISSING_PW_CONFIRM';
var ERR_INVALID_PW = exports.ERR_INVALID_PW = 'ERR_INVALID_PW';
var ERR_PW_NOT_CONFIRMED = exports.ERR_PW_NOT_CONFIRMED = 'ERR_PW_NOT_CONFIRMED';

/*
 * Login errors
 */

var ERR_INVALID_CREDENTIALS = exports.ERR_INVALID_CREDENTIALS = 'ERR_INVALID_CREDENTIALS';
var ERR_NETWORK = exports.ERR_NETWORK = 'ERR_NETWORK';
var ERR_WRONG_TENANT = exports.ERR_WRONG_TENANT = 'ERR_WRONG_TENANT';