'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.IntlAwareDateInput = IntlAwareDateInput;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DateInput = _cspaceInput.components.DateInput;


var propTypes = {
  intl: _reactIntl.intlShape
};

function IntlAwareDateInput(props) {
  var intl = props.intl,
      remainingProps = _objectWithoutProperties(props, ['intl']);

  var locale = intl.locale;

  return _react2.default.createElement(DateInput, _extends({}, remainingProps, {
    locale: locale
  }));
}

IntlAwareDateInput.propTypes = propTypes;

var IntlizedDateInput = (0, _reactIntl.injectIntl)(IntlAwareDateInput);

IntlizedDateInput.propTypes = DateInput.propTypes;

exports.default = IntlizedDateInput;