'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactRedux = require('react-redux');

var _QuickSearchForm = require('../../components/search/QuickSearchForm');

var _QuickSearchForm2 = _interopRequireDefault(_QuickSearchForm);

var _quickSearch = require('../../actions/quickSearch');

var _prefs = require('../../actions/prefs');

var _reducers = require('../../reducers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  var recordType = (0, _reducers.getQuickSearchRecordType)(state);

  return {
    keywordValue: (0, _reducers.getQuickSearchKeyword)(state),
    recordTypeValue: recordType,
    vocabularyValue: (0, _reducers.getQuickSearchVocabulary)(state, recordType)
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch, ownProps) {
  return {
    onKeywordCommit: function onKeywordCommit(value) {
      dispatch((0, _quickSearch.setQuickSearchKeyword)(value));
    },
    onRecordTypeCommit: function onRecordTypeCommit(value) {
      dispatch((0, _prefs.setQuickSearchRecordType)(value));
    },
    onVocabularyCommit: function onVocabularyCommit(value) {
      dispatch((0, _prefs.setQuickSearchVocabulary)(value));
    },
    search: function search() {
      dispatch((0, _quickSearch.initiateSearch)(ownProps.history.push));
    }
  };
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(_QuickSearchForm2.default);