'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

exports.default = function (pluginContext) {
  var formatOption = pluginContext.formatHelpers.formatOption;


  return {
    default: {
      screenName: {
        messages: (0, _reactIntl.defineMessages)({
          label: {
            'id': 'column.account.default.screenName',
            'defaultMessage': 'Full Name'
          }
        }),
        order: 10,
        width: 250
      },
      status: {
        formatValue: function formatValue(data, formatterContext) {
          return formatOption('accountStatuses', data, formatterContext);
        },
        messages: (0, _reactIntl.defineMessages)({
          label: {
            'id': 'column.account.default.status',
            'defaultMessage': 'Status'
          }
        }),
        order: 20,
        width: 50
      }
    }
  };
};