'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (pluginContext) {
  var _pluginContext$search = pluginContext.searchOperators,
      OP_OR = _pluginContext$search.OP_OR,
      OP_EQ = _pluginContext$search.OP_EQ,
      OP_CONTAIN = _pluginContext$search.OP_CONTAIN;
  var extensions = pluginContext.config.extensions;


  return {
    op: OP_OR,
    value: [{
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/objectNumber'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/responsibleDepartments/responsibleDepartment'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/collection'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/recordStatus'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/titleGroupList/titleGroup/title'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/objectNameList/objectNameGroup/objectName'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/objectStatusList/objectStatus'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/sex'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/phase'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/forms/form'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/editionNumber'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/styles/style'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/materialGroupList/materialGroup/material'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/objectComponentGroupList/objectComponentGroup/objectComponentName'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/technicalAttributeGroupList/technicalAttributeGroup/technicalAttribute'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/nonTextualInscriptionGroupList/nonTextualInscriptionGroup/inscriptionDescriptionInscriber'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/nonTextualInscriptionGroupList/nonTextualInscriptionGroup/inscriptionDescriptionMethod'
    },
    /* eslint-disable max-len */
    // {
    //   op: OP_RANGE,
    //   path: 'ns2:collectionobjects_common/objectProductionDateGroupList/objectProductionDateGroup',
    // },
    /* eslint-enable max-len */
    {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/techniqueGroupList/techniqueGroup/technique'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/objectProductionPlaceGroupList/objectProductionPlaceGroup/objectProductionPlace'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/objectProductionPeopleGroupList/objectProductionPeopleGroup/objectProductionPeople'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/objectProductionPersonGroupList/objectProductionPersonGroup/objectProductionPerson'
    }, {
      op: OP_EQ,
      path: 'ns2:collectionobjects_common/objectProductionOrganizationGroupList/objectProductionOrganizationGroup/objectProductionOrganization'
    }, {
      op: OP_CONTAIN,
      path: 'ns2:collectionobjects_common/fieldColEventNames/fieldColEventName'
    }].concat(_toConsumableArray(extensions.core.advancedSearch))
  };
};