"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require("react-intl");

var template = function template(pluginContext) {
  var React = pluginContext.lib.React;
  var Field = pluginContext.recordComponents.Field;


  return React.createElement(
    Field,
    { name: "document" },
    React.createElement(Field, {
      name: "relation-list-item",
      subpath: "rel:relations-common-list",
      showChildren: false,
      showSiblings: false
    }),
    React.createElement(
      Field,
      { name: "conceptRecordTypes" },
      React.createElement(Field, { name: "conceptRecordType" })
    )
  );
};

exports.default = function (pluginContext) {
  return {
    disabled: true,
    messages: (0, _reactIntl.defineMessages)({
      name: {
        "id": "form.concept.mini.name",
        "defaultMessage": "Mini Template"
      }
    }),
    template: template(pluginContext)
  };
};