'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (pluginContext) {
  var _pluginContext$search = pluginContext.searchOperators,
      OP_OR = _pluginContext$search.OP_OR,
      OP_EQ = _pluginContext$search.OP_EQ,
      OP_CONTAIN = _pluginContext$search.OP_CONTAIN,
      OP_RANGE = _pluginContext$search.OP_RANGE;
  var extensions = pluginContext.config.extensions;


  return {
    op: OP_OR,
    value: [{
      op: OP_CONTAIN,
      path: 'ns2:conservation_common/conservationNumber'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/conservationStatusGroupList/conservationStatusGroup/status'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/treatmentPurpose'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/conservators/conservator'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/approvedBy'
    }, {
      op: OP_RANGE,
      path: 'ns2:conservation_common/approvedDate'
    }, {
      op: OP_RANGE,
      path: 'ns2:conservation_common/treatmentStartDate'
    }, {
      op: OP_RANGE,
      path: 'ns2:conservation_common/treatmentEndDate'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/researcher'
    }, {
      op: OP_RANGE,
      path: 'ns2:conservation_common/proposedAnalysisDate'
    }, {
      op: OP_EQ,
      path: 'ns2:conservation_common/destAnalysisGroupList/destAnalysisGroup/sampleBy'
    }].concat(_toConsumableArray(extensions.core.advancedSearch))
  };
};