"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require("react-intl");

var template = function template(pluginContext) {
  var React = pluginContext.lib.React;
  var _pluginContext$layout = pluginContext.layoutComponents,
      Col = _pluginContext$layout.Col,
      Panel = _pluginContext$layout.Panel,
      Row = _pluginContext$layout.Row;
  var Field = pluginContext.recordComponents.Field;


  return React.createElement(
    Field,
    { name: "document" },
    React.createElement(
      Panel,
      { name: "info", collapsible: true, collapsed: true },
      React.createElement(
        Row,
        null,
        React.createElement(
          Col,
          null,
          React.createElement(
            Field,
            { name: "emailGroupList" },
            React.createElement(
              Field,
              { name: "emailGroup" },
              React.createElement(Field, { name: "email" }),
              React.createElement(Field, { name: "emailType" })
            )
          ),
          React.createElement(
            Field,
            { name: "telephoneNumberGroupList" },
            React.createElement(
              Field,
              { name: "telephoneNumberGroup" },
              React.createElement(Field, { name: "telephoneNumber" }),
              React.createElement(Field, { name: "telephoneNumberType" })
            )
          )
        ),
        React.createElement(
          Col,
          null,
          React.createElement(
            Field,
            { name: "faxNumberGroupList" },
            React.createElement(
              Field,
              { name: "faxNumberGroup" },
              React.createElement(Field, { name: "faxNumber" }),
              React.createElement(Field, { name: "faxNumberType" })
            )
          ),
          React.createElement(
            Field,
            { name: "webAddressGroupList" },
            React.createElement(
              Field,
              { name: "webAddressGroup" },
              React.createElement(Field, { name: "webAddress" }),
              React.createElement(Field, { name: "webAddressType" })
            )
          )
        )
      ),
      React.createElement(
        Field,
        { name: "addressGroupList" },
        React.createElement(
          Field,
          { name: "addressGroup" },
          React.createElement(
            Panel,
            null,
            React.createElement(
              Row,
              null,
              React.createElement(
                Col,
                null,
                React.createElement(Field, { name: "addressPlace1" }),
                React.createElement(Field, { name: "addressPlace2" }),
                React.createElement(Field, { name: "addressMunicipality" })
              ),
              React.createElement(
                Col,
                null,
                React.createElement(
                  Row,
                  null,
                  React.createElement(Field, { name: "addressStateOrProvince" }),
                  React.createElement(Field, { name: "addressPostCode" })
                ),
                React.createElement(Field, { name: "addressCountry" }),
                React.createElement(
                  Row,
                  null,
                  React.createElement(
                    Col,
                    null,
                    React.createElement(Field, { name: "addressType" })
                  ),
                  React.createElement(Col, null)
                )
              )
            )
          )
        )
      )
    )
  );
};

exports.default = function (pluginContext) {
  return {
    messages: (0, _reactIntl.defineMessages)({
      name: {
        "id": "form.contact.default.name",
        "defaultMessage": "Standard Template"
      }
    }),
    template: template(pluginContext)
  };
};