'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

// FIXME: Plugins shouldn't have to import react-intl, since this unnecessarily increases the size
// when built as a standalone package. Instead, defineMessages should be supplied in the
// pluginContext. But this means that messages won't be extracted by the Babel plugin, since it
// only operates on files that import react-intl.

exports.default = {
  locationTermTypes: {
    values: ['descriptor', 'alternate descriptor', 'used for term'],
    messages: (0, _reactIntl.defineMessages)({
      descriptor: {
        'id': 'option.locationTermTypes.descriptor',
        'defaultMessage': 'descriptor'
      },
      'alternate descriptor': {
        'id': 'option.locationTermTypes.alternate descriptor',
        'defaultMessage': 'alternate descriptor'
      },
      'used for term': {
        'id': 'option.locationTermTypes.used for term',
        'defaultMessage': 'used for term'
      }
    })
  },
  locationTermStatuses: {
    values: ['provisional', 'under review', 'accepted', 'rejected'],
    messages: (0, _reactIntl.defineMessages)({
      provisional: {
        'id': 'option.locationTermStatuses.provisional',
        'defaultMessage': 'provisional'
      },
      'under review': {
        'id': 'option.locationTermStatuses.under review',
        'defaultMessage': 'under review'
      },
      accepted: {
        'id': 'option.locationTermStatuses.accepted',
        'defaultMessage': 'accepted'
      },
      rejected: {
        'id': 'option.locationTermStatuses.rejected',
        'defaultMessage': 'rejected'
      }
    })
  }
};