"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require("react-intl");

var template = function template(pluginContext) {
  var React = pluginContext.lib.React;
  var _pluginContext$layout = pluginContext.layoutComponents,
      Col = _pluginContext$layout.Col,
      Panel = _pluginContext$layout.Panel,
      Row = _pluginContext$layout.Row;
  var _pluginContext$record = pluginContext.recordComponents,
      InputTable = _pluginContext$record.InputTable,
      Field = _pluginContext$record.Field,
      Subrecord = _pluginContext$record.Subrecord;


  return React.createElement(
    Field,
    { name: "document" },
    React.createElement(
      Panel,
      { name: "info", collapsible: true },
      React.createElement(
        Field,
        { name: "personTermGroupList" },
        React.createElement(
          Field,
          { name: "personTermGroup" },
          React.createElement(
            Panel,
            null,
            React.createElement(
              Row,
              null,
              React.createElement(Field, { name: "termDisplayName" }),
              React.createElement(Field, { name: "termName" }),
              React.createElement(Field, { name: "termQualifier" }),
              React.createElement(Field, { name: "termStatus" })
            ),
            React.createElement(
              Row,
              null,
              React.createElement(Field, { name: "termType" }),
              React.createElement(Field, { name: "termFlag" }),
              React.createElement(Field, { name: "termLanguage" }),
              React.createElement(Field, { name: "termPrefForLang" })
            ),
            React.createElement(
              InputTable,
              { name: "nameDetail" },
              React.createElement(Field, { name: "salutation" }),
              React.createElement(Field, { name: "title" }),
              React.createElement(Field, { name: "foreName" }),
              React.createElement(Field, { name: "middleName" }),
              React.createElement(Field, { name: "surName" }),
              React.createElement(Field, { name: "nameAdditions" }),
              React.createElement(Field, { name: "initials" })
            ),
            React.createElement(
              InputTable,
              { name: "termSource" },
              React.createElement(Field, { name: "termSource" }),
              React.createElement(Field, { name: "termSourceDetail" }),
              React.createElement(Field, { name: "termSourceID" }),
              React.createElement(Field, { name: "termSourceNote" })
            )
          )
        )
      ),
      React.createElement(
        Row,
        null,
        React.createElement(
          Col,
          null,
          React.createElement(Field, { name: "gender" }),
          React.createElement(
            Field,
            { name: "occupations" },
            React.createElement(Field, { name: "occupation" })
          ),
          React.createElement(
            Field,
            { name: "schoolsOrStyles" },
            React.createElement(Field, { name: "schoolOrStyle" })
          ),
          React.createElement(
            Field,
            { name: "groups" },
            React.createElement(Field, { name: "group" })
          ),
          React.createElement(
            Field,
            { name: "nationalities" },
            React.createElement(Field, { name: "nationality" })
          )
        ),
        React.createElement(
          Col,
          null,
          React.createElement(Field, { name: "nameNote" }),
          React.createElement(
            Row,
            null,
            React.createElement(Field, { name: "birthDateGroup" }),
            React.createElement(Field, { name: "birthPlace" })
          ),
          React.createElement(
            Row,
            null,
            React.createElement(Field, { name: "deathDateGroup" }),
            React.createElement(Field, { name: "deathPlace" })
          ),
          React.createElement(Field, { name: "bioNote" })
        )
      )
    ),
    React.createElement(Subrecord, { name: "contact" }),
    React.createElement(
      Panel,
      { name: "hierarchy", collapsible: true, collapsed: true },
      React.createElement(Field, { name: "relation-list-item", subpath: "rel:relations-common-list" })
    )
  );
};

exports.default = function (pluginContext) {
  return {
    messages: (0, _reactIntl.defineMessages)({
      name: {
        "id": "form.person.default.name",
        "defaultMessage": "Standard Template"
      }
    }),
    template: template(pluginContext)
  };
};