'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Page2 = require('./Page');

var _Page3 = _interopRequireDefault(_Page2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CreatePage = function (_Page) {
  _inherits(CreatePage, _Page);

  function CreatePage() {
    _classCallCheck(this, CreatePage);

    var _this = _possibleConstructorReturn(this, (CreatePage.__proto__ || Object.getPrototypeOf(CreatePage)).call(this));

    _this.url = '/create';
    _this.selector = '.cspace-ui-CreatePage--common';
    return _this;
  }

  _createClass(CreatePage, [{
    key: 'hasRecordType',
    value: function hasRecordType(recordTypeDescriptor) {
      var link = this.getRecordLink(recordTypeDescriptor);

      return !!link && link.isVisible();
    }
  }, {
    key: 'hasVocabulary',
    value: function hasVocabulary(vocabularyDescriptor) {
      var link = this.getVocabularyLink(vocabularyDescriptor);

      return !!link && link.isVisible();
    }
  }, {
    key: 'getRecordLink',
    value: function getRecordLink(recordTypeDescriptor) {
      var serviceType = recordTypeDescriptor.serviceType,
          name = recordTypeDescriptor.name,
          displayName = recordTypeDescriptor.displayName;


      var container = typeof serviceType !== 'undefined' ? browser.$(this.selector).$('.cspace-ui-CreatePagePanel--' + serviceType) : browser.$(this.selector);

      if (!container) {
        return null;
      }

      var links = container.$$('*[id="' + name + '"]');

      if (links.length === 0) {
        return null;
      }

      var link = links[0];

      if (typeof displayName !== 'undefined' && link.getText() !== displayName) {
        return null;
      }

      if (typeof name !== 'undefined' && typeof serviceType !== 'undefined' && serviceType !== 'authority') {
        var url = '/record/' + name;
        var href = link.getAttribute('href');

        if (!href || !href.endsWith(url)) {
          return null;
        }
      }

      return link;
    }
  }, {
    key: 'getVocabularyLink',
    value: function getVocabularyLink(vocabularyDescriptor) {
      var authorityName = vocabularyDescriptor.authorityName,
          name = vocabularyDescriptor.name,
          displayName = vocabularyDescriptor.displayName;


      var recordLink = this.getRecordLink({
        name: authorityName,
        serviceType: 'authority'
      });

      if (!recordLink) {
        return null;
      }

      var container = recordLink.$('..');

      if (!container) {
        return null;
      }

      var links = container.$$('a[id="' + authorityName + '/' + name + '"]');

      if (links.length === 0) {
        return null;
      }

      var link = links[0];

      if (typeof displayName !== 'undefined' && link.getText() !== displayName) {
        return null;
      }

      if (typeof name !== 'undefined') {
        var url = '/record/' + authorityName + '/' + name;
        var href = link.getAttribute('href');

        if (!href || !href.endsWith(url)) {
          return null;
        }
      }

      return link;
    }
  }]);

  return CreatePage;
}(_Page3.default);

exports.default = CreatePage;